Merge branch 'master' of http://repo.or.cz/r/msysgit into devel
[msysgit/historical-msysgit.git] / git / git-am.sh
blobe5e6f2c91c1faf58239ab73672fbb05cda91762f
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8 | --no-utf8] [--binary] [--3way]
6 [--interactive] [--whitespace=<option>] [-C<n>] [-p<n>] <mbox>...
7 or, when resuming [--skip | --resolved]'
8 . git-sh-setup
9 set_reflog_action am
10 require_work_tree
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
14 stop_here () {
15 echo "$1" >"$dotest/next"
16 exit 1
19 stop_here_user_resolve () {
20 if [ -n "$resolvemsg" ]; then
21 printf '%s\n' "$resolvemsg"
22 stop_here $1
24 cmdline=$(basename $0)
25 if test '' != "$interactive"
26 then
27 cmdline="$cmdline -i"
29 if test '' != "$threeway"
30 then
31 cmdline="$cmdline -3"
33 if test '.dotest' != "$dotest"
34 then
35 cmdline="$cmdline -d=$dotest"
37 echo "When you have resolved this problem run \"$cmdline --resolved\"."
38 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
40 stop_here $1
43 go_next () {
44 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45 "$dotest/patch" "$dotest/info"
46 echo "$next" >"$dotest/next"
47 this=$next
50 cannot_fallback () {
51 echo "$1"
52 echo "Cannot fall back to three-way merge."
53 exit 1
56 fall_back_3way () {
57 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
59 rm -fr "$dotest"/patch-merge-*
60 mkdir "$dotest/patch-merge-tmp-dir"
62 # First see if the patch records the index info that we can use.
63 git apply -z --index-info "$dotest/patch" \
64 >"$dotest/patch-merge-index-info" &&
65 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66 git update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68 git write-tree >"$dotest/patch-merge-base+" ||
69 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
71 echo Using index info to reconstruct a base tree...
72 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73 git apply $binary --cached <"$dotest/patch"
74 then
75 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77 else
78 cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
82 test -f "$dotest/patch-merge-index" &&
83 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
84 orig_tree=$(cat "$dotest/patch-merge-base") &&
85 rm -fr "$dotest"/patch-merge-* || exit 1
87 echo Falling back to patching base and 3-way merge...
89 # This is not so wrong. Depending on which base we picked,
90 # orig_tree may be wildly different from ours, but his_tree
91 # has the same set of wildly different changes in parts the
92 # patch did not touch, so recursive ends up canceling them,
93 # saying that we reverted all those changes.
95 eval GITHEAD_$his_tree='"$SUBJECT"'
96 export GITHEAD_$his_tree
97 git-merge-recursive $orig_tree -- HEAD $his_tree || {
98 git rerere
99 echo Failed to merge in the changes.
100 exit 1
102 unset GITHEAD_$his_tree
105 prec=4
106 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary= resolvemsg=
107 git_apply_opt=
109 while case "$#" in 0) break;; esac
111 case "$1" in
112 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
113 dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
114 -d|--d|--do|--dot|--dote|--dotes|--dotest)
115 case "$#" in 1) usage ;; esac; shift
116 dotest="$1"; shift;;
118 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
119 --interacti|--interactiv|--interactive)
120 interactive=t; shift ;;
122 -b|--b|--bi|--bin|--bina|--binar|--binary)
123 binary=t; shift ;;
125 -3|--3|--3w|--3wa|--3way)
126 threeway=t; shift ;;
127 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
128 sign=t; shift ;;
129 -u|--u|--ut|--utf|--utf8)
130 utf8=t; shift ;; # this is now default
131 --no-u|--no-ut|--no-utf|--no-utf8)
132 utf8=; shift ;;
133 -k|--k|--ke|--kee|--keep)
134 keep=t; shift ;;
136 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
137 resolved=t; shift ;;
139 --sk|--ski|--skip)
140 skip=t; shift ;;
142 --whitespace=*|-C*|-p*)
143 git_apply_opt="$git_apply_opt $1"; shift ;;
145 --resolvemsg=*)
146 resolvemsg=${1#--resolvemsg=}; shift ;;
149 shift; break ;;
151 usage ;;
153 break ;;
154 esac
155 done
157 # If the dotest directory exists, but we have finished applying all the
158 # patches in them, clear it out.
159 if test -d "$dotest" &&
160 last=$(cat "$dotest/last") &&
161 next=$(cat "$dotest/next") &&
162 test $# != 0 &&
163 test "$next" -gt "$last"
164 then
165 rm -fr "$dotest"
168 if test -d "$dotest"
169 then
170 case "$#,$skip$resolved" in
171 0,*t*)
172 # Explicit resume command and we do not have file, so
173 # we are happy.
174 : ;;
176 # No file input but without resume parameters; catch
177 # user error to feed us a patch from standard input
178 # when there is already .dotest. This is somewhat
179 # unreliable -- stdin could be /dev/null for example
180 # and the caller did not intend to feed us a patch but
181 # wanted to continue unattended.
182 tty -s
185 false
187 esac ||
188 die "previous dotest directory $dotest still exists but mbox given."
189 resume=yes
190 else
191 # Make sure we are not given --skip nor --resolved
192 test ",$skip,$resolved," = ,,, ||
193 die "Resolve operation not in progress, we are not resuming."
195 # Start afresh.
196 mkdir -p "$dotest" || exit
198 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
199 rm -fr "$dotest"
200 exit 1
203 # -b, -s, -u, -k and --whitespace flags are kept for the
204 # resuming session after a patch failure.
205 # -3 and -i can and must be given when resuming.
206 echo "$binary" >"$dotest/binary"
207 echo " $ws" >"$dotest/whitespace"
208 echo "$sign" >"$dotest/sign"
209 echo "$utf8" >"$dotest/utf8"
210 echo "$keep" >"$dotest/keep"
211 echo 1 >"$dotest/next"
214 case "$resolved" in
216 files=$(git diff-index --cached --name-only HEAD) || exit
217 if [ "$files" ]; then
218 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
219 exit 1
221 esac
223 if test "$(cat "$dotest/binary")" = t
224 then
225 binary=--allow-binary-replacement
227 if test "$(cat "$dotest/utf8")" = t
228 then
229 utf8=-u
230 else
231 utf8=-n
233 if test "$(cat "$dotest/keep")" = t
234 then
235 keep=-k
237 ws=`cat "$dotest/whitespace"`
238 if test "$(cat "$dotest/sign")" = t
239 then
240 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
241 s/>.*/>/
242 s/^/Signed-off-by: /'
244 else
245 SIGNOFF=
248 last=`cat "$dotest/last"`
249 this=`cat "$dotest/next"`
250 if test "$skip" = t
251 then
252 git rerere clear
253 this=`expr "$this" + 1`
254 resume=
257 if test "$this" -gt "$last"
258 then
259 echo Nothing to do.
260 rm -fr "$dotest"
261 exit
264 while test "$this" -le "$last"
266 msgnum=`printf "%0${prec}d" $this`
267 next=`expr "$this" + 1`
268 test -f "$dotest/$msgnum" || {
269 resume=
270 go_next
271 continue
274 # If we are not resuming, parse and extract the patch information
275 # into separate files:
276 # - info records the authorship and title
277 # - msg is the rest of commit log message
278 # - patch is the patch body.
280 # When we are resuming, these files are either already prepared
281 # by the user, or the user can tell us to do so by --resolved flag.
282 case "$resume" in
284 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
285 <"$dotest/$msgnum" >"$dotest/info" ||
286 stop_here $this
287 test -s $dotest/patch || {
288 echo "Patch is empty. Was it split wrong?"
289 stop_here $this
291 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
293 esac
295 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
296 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
297 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
299 if test -z "$GIT_AUTHOR_EMAIL"
300 then
301 echo "Patch does not have a valid e-mail address."
302 stop_here $this
305 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
307 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
308 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
310 case "$resume" in
312 if test '' != "$SIGNOFF"
313 then
314 LAST_SIGNED_OFF_BY=`
315 sed -ne '/^Signed-off-by: /p' \
316 "$dotest/msg-clean" |
317 tail -n 1
319 ADD_SIGNOFF=`
320 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
321 test '' = "$LAST_SIGNED_OFF_BY" && echo
322 echo "$SIGNOFF"
324 else
325 ADD_SIGNOFF=
328 printf '%s\n' "$SUBJECT"
329 if test -s "$dotest/msg-clean"
330 then
331 echo
332 cat "$dotest/msg-clean"
334 if test '' != "$ADD_SIGNOFF"
335 then
336 echo "$ADD_SIGNOFF"
338 } >"$dotest/final-commit"
341 case "$resolved$interactive" in
343 # This is used only for interactive view option.
344 git diff-index -p --cached HEAD >"$dotest/patch"
346 esac
347 esac
349 resume=
350 if test "$interactive" = t
351 then
352 test -t 0 ||
353 die "cannot be interactive without stdin connected to a terminal."
354 action=again
355 while test "$action" = again
357 echo "Commit Body is:"
358 echo "--------------------------"
359 cat "$dotest/final-commit"
360 echo "--------------------------"
361 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
362 read reply
363 case "$reply" in
364 [yY]*) action=yes ;;
365 [aA]*) action=yes interactive= ;;
366 [nN]*) action=skip ;;
367 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
368 action=again ;;
369 [vV]*) action=again
370 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
371 *) action=again ;;
372 esac
373 done
374 else
375 action=yes
378 if test $action = skip
379 then
380 go_next
381 continue
384 if test -x "$GIT_DIR"/hooks/applypatch-msg
385 then
386 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
387 stop_here $this
390 echo
391 printf 'Applying %s\n' "$SUBJECT"
392 echo
394 case "$resolved" in
396 git apply $git_apply_opt $binary --index "$dotest/patch"
397 apply_status=$?
400 # Resolved means the user did all the hard work, and
401 # we do not have to do any patch application. Just
402 # trust what the user has in the index file and the
403 # working tree.
404 resolved=
405 git diff-index --quiet --cached HEAD && {
406 echo "No changes - did you forget to use 'git add'?"
407 stop_here_user_resolve $this
409 unmerged=$(git ls-files -u)
410 if test -n "$unmerged"
411 then
412 echo "You still have unmerged paths in your index"
413 echo "did you forget to use 'git add'?"
414 stop_here_user_resolve $this
416 apply_status=0
417 git rerere
419 esac
421 if test $apply_status = 1 && test "$threeway" = t
422 then
423 if (fall_back_3way)
424 then
425 # Applying the patch to an earlier tree and merging the
426 # result may have produced the same tree as ours.
427 git diff-index --quiet --cached HEAD && {
428 echo No changes -- Patch already applied.
429 go_next
430 continue
432 # clear apply_status -- we have successfully merged.
433 apply_status=0
436 if test $apply_status != 0
437 then
438 echo Patch failed at $msgnum.
439 stop_here_user_resolve $this
442 if test -x "$GIT_DIR"/hooks/pre-applypatch
443 then
444 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
447 tree=$(git write-tree) &&
448 echo Wrote tree $tree &&
449 parent=$(git rev-parse --verify HEAD) &&
450 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
451 echo Committed: $commit &&
452 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
453 stop_here $this
455 if test -x "$GIT_DIR"/hooks/post-applypatch
456 then
457 "$GIT_DIR"/hooks/post-applypatch
460 go_next
461 done
463 rm -fr "$dotest"